"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function ArrayFieldTitle(_ref) {
  var TitleField = _ref.TitleField,
      idSchema = _ref.idSchema,
      title = _ref.title,
      required = _ref.required;

  if (!title) {
    // See #312: Ensure compatibility with old versions of React.
    return _react2.default.createElement("div", null);
  }
  var id = idSchema.$id + "__title";
  return _react2.default.createElement(TitleField, { id: id, title: title, required: required });
}

function ArrayFieldDescription(_ref2) {
  var DescriptionField = _ref2.DescriptionField,
      idSchema = _ref2.idSchema,
      description = _ref2.description;

  if (!description) {
    // See #312: Ensure compatibility with old versions of React.
    return _react2.default.createElement("div", null);
  }
  var id = idSchema.$id + "__description";
  return _react2.default.createElement(DescriptionField, { id: id, description: description });
}

function IconBtn(props) {
  var _props$type = props.type,
      type = _props$type === undefined ? "default" : _props$type,
      icon = props.icon,
      className = props.className,
      otherProps = _objectWithoutProperties(props, ["type", "icon", "className"]);

  return _react2.default.createElement(
    "button",
    _extends({ type: "button", className: "btn btn-" + type + " " + className }, otherProps),
    _react2.default.createElement("i", { className: "glyphicon glyphicon-" + icon })
  );
}

var ArrayField = function (_Component) {
  _inherits(ArrayField, _Component);

  function ArrayField(props) {
    _classCallCheck(this, ArrayField);

    var _this = _possibleConstructorReturn(this, (ArrayField.__proto__ || Object.getPrototypeOf(ArrayField)).call(this, props));

    _initialiseProps.call(_this);

    var formData = _this.getStateFromProps(props);
    var anyOfItems = [];
    if (_this.getAnyOfItemsSchema()) {
      // We need to contruct the initial anyOfItems state, by searching for the props anyOf items
      // in the available anyOf schema items
//		props.schema.items.anyOf.map(function(_data){
//	      	var data = {};
//			Object.keys(_data.properties).forEach(function(key) {
//				data[key] = undefined;
//			});
//			data['type'] = _data.$id;
//			formData.items.push(data);
//		});


      anyOfItems = _this.getAnyOfItemsFromProps(formData.items, props.schema.items.anyOf);
    }
    _this.state = { formData: formData, anyOfItems: anyOfItems };
    return _this;
  }

  _createClass(ArrayField, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var newState = Object.assign({}, this.state, { formData: this.getStateFromProps(nextProps) });
      this.setState(newState);
    }
  }, {
    key: "getStateFromProps",
    value: function getStateFromProps(props) {
      var formData = Array.isArray(props.formData) ? props.formData : null;
      var definitions = this.props.registry.definitions;

      return {
        items: (0, _utils.getDefaultFormState)(props.schema, formData, definitions) || []
      };
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _utils.shouldRender)(this, nextProps, nextState);
    }
  }, {
    key: "getAnyOfItemsFromProps",
    value: function getAnyOfItemsFromProps(formDataItems, anyOfSchema) {
      var _this2 = this;

      return formDataItems.map(function (item) {
        var type = typeof item === "undefined" ? "undefined" : _typeof(item);
        var itemType = type === "object" && Array.isArray(item) ? "array" : type;
        var schema = {};

        if('$id' in item)
        {
    		schema = anyOfSchema.find(s => s.$id == item.$id);
        }
	    else 
	    {
	    	schema = _this2.getAnyOfItemSchema(anyOfSchema, itemType);
	    }

         

        // If this schema is an array, we need to recursively add its contents
        if (schema.type === "array") {
          _this2.getAnyOfItemsFromProps(item, schema.items.anyOf);
        }

        return schema;
      });
    }
  }, {
    key: "getAnyOfItemSchema",
    value: function getAnyOfItemSchema(anyOfSchema, type) {
      return anyOfSchema.find(function (schemaElement) {
        var schemaElementType = schemaElement.type === "integer" ? "number" : schemaElement.type;
        return schemaElementType === type;
      });
    }
  }, {
    key: "isItemRequired",
    value: function isItemRequired(itemsSchema) {
      return itemsSchema.type === "string" && itemsSchema.minLength > 0;
    }
  }, {
    key: "asyncSetState",
    value: function asyncSetState(state) {
      var _this3 = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { validate: false };

      (0, _utils.setState)(this, state, function () {
        _this3.props.onChange(_this3.state.formData.items, options);
      });
    }
  }, {
    key: "getAnyOfItemsSchema",
    value: function getAnyOfItemsSchema() {
      var schema = this.props.schema;

      return schema.items.anyOf;
    }
  }, {
    key: "anyOfOptions",
    value: function anyOfOptions(anyOfItems) {
      return anyOfItems.map(function (item) {
        return { value: item.$id, label: item.$id };
      });
    }
  }, {
    key: "setWidgetType",
    value: function setWidgetType(index, value) {
      var items = this.state.formData.items;
      var registry = this.props.registry;
      var definitions = registry.definitions;

      var anyOfItemsSchema = this.getAnyOfItemsSchema();
      var newItems = items.slice();
      var foundItem = anyOfItemsSchema.find(function (element) {
        return element.$id === value;
      });
      newItems[index] = (0, _utils.getDefaultFormState)(foundItem, undefined, definitions);

      var newAnyOfItems = [].concat(_toConsumableArray(this.state.anyOfItems));
      newAnyOfItems[index] = foundItem;

      if(!('$id' in newItems[index]))
      {
      	newItems[index]['$id'] = foundItem.$id;
      }

      var newState = Object.assign({}, this.state, { formData: { items: newItems }, anyOfItems: newAnyOfItems });

      this.asyncSetState(newState);
    }
  }, {
    key: "render",
    value: function render() {
      var _props = this.props,
          schema = _props.schema,
          uiSchema = _props.uiSchema;

      if ((0, _utils.isFilesArray)(schema, uiSchema)) {
        return this.renderFiles();
      }
      if ((0, _utils.isFixedItems)(schema)) {
        return this.renderFixedArray();
      }
      if ((0, _utils.isMultiSelect)(schema)) {
        return this.renderMultiSelect();
      }
      return this.renderNormalArray();
    }
  }, {
    key: "renderNormalArray",
    value: function renderNormalArray() {
      var _this4 = this;

      var _props2 = this.props,
          schema = _props2.schema,
          uiSchema = _props2.uiSchema,
          errorSchema = _props2.errorSchema,
          idSchema = _props2.idSchema,
          name = _props2.name,
          required = _props2.required,
          disabled = _props2.disabled,
          readonly = _props2.readonly,
          autofocus = _props2.autofocus;

      var title = schema.title === undefined ? name : schema.title;
      var _state = this.state,
          items = _state.formData.items,
          anyOfItems = _state.anyOfItems;
      var _props$registry = this.props.registry,
          definitions = _props$registry.definitions,
          fields = _props$registry.fields;
      var TitleField = fields.TitleField,
          DescriptionField = fields.DescriptionField;

      var itemsSchema = (0, _utils.retrieveSchema)(schema.items, definitions);

      var _getUiOptions = (0, _utils.getUiOptions)(uiSchema),
          _getUiOptions$addable = _getUiOptions.addable,
          addable = _getUiOptions$addable === undefined ? true : _getUiOptions$addable;

      var anyOfItemsSchema = this.getAnyOfItemsSchema();

      return _react2.default.createElement(
        "fieldset",
        {
          className: "field field-array field-array-of-" + itemsSchema.type },
        _react2.default.createElement(ArrayFieldTitle, {
          TitleField: TitleField,
          idSchema: idSchema,
          title: title,
          required: required }),
        schema.description ? _react2.default.createElement(ArrayFieldDescription, {
          DescriptionField: DescriptionField,
          idSchema: idSchema,
          description: schema.description }) : null,
        _react2.default.createElement(
          "div",
          { className: "row array-item-list" },
          items.map(function (item, index) {
            if (anyOfItemsSchema) {
              itemsSchema = anyOfItems[index];
            }
            var itemErrorSchema = errorSchema ? errorSchema[index] : undefined;
            var itemIdPrefix = idSchema.$id + "_" + index;
            var itemIdSchema = (0, _utils.toIdSchema)(itemsSchema, itemIdPrefix, definitions);
            return _this4.renderArrayFieldItem({
              index: index,
              canMoveUp: index > 0,
              canMoveDown: index < items.length - 1,
              itemSchema: itemsSchema,
              itemIdSchema: itemIdSchema,
              itemErrorSchema: itemErrorSchema,
              itemData: items[index],
              itemUiSchema: uiSchema.items,
              autofocus: autofocus && index === 0,
              anyOfItemsSchema: anyOfItemsSchema,
              selectWidgetValue: anyOfItems.length > 0 ? anyOfItems[index].$id : ""
            });
          })
        ),
        addable ? _react2.default.createElement(AddButton, {
          onClick: this.onAddClick,
          disabled: disabled || readonly }) : null
      );
    }
  }, {
    key: "renderMultiSelect",
    value: function renderMultiSelect() {
      var _props3 = this.props,
          schema = _props3.schema,
          idSchema = _props3.idSchema,
          uiSchema = _props3.uiSchema,
          disabled = _props3.disabled,
          readonly = _props3.readonly,
          autofocus = _props3.autofocus;
      var items = this.state.formData.items;
      var _props$registry2 = this.props.registry,
          widgets = _props$registry2.widgets,
          definitions = _props$registry2.definitions;

      var itemsSchema = (0, _utils.retrieveSchema)(schema.items, definitions);
      var enumOptions = (0, _utils.optionsList)(itemsSchema);

      var _getUiOptions$enumOpt = _extends({}, (0, _utils.getUiOptions)(uiSchema), { enumOptions: enumOptions }),
          _getUiOptions$enumOpt2 = _getUiOptions$enumOpt.widget,
          widget = _getUiOptions$enumOpt2 === undefined ? "select" : _getUiOptions$enumOpt2,
          options = _objectWithoutProperties(_getUiOptions$enumOpt, ["widget"]);

      var Widget = (0, _utils.getWidget)(schema, widget, widgets);
      return _react2.default.createElement(Widget, {
        id: idSchema && idSchema.$id,
        multiple: true,
        onChange: this.onSelectChange,
        options: options,
        schema: schema,
        value: items,
        disabled: disabled,
        readonly: readonly,
        autofocus: autofocus });
    }
  }, {
    key: "renderFiles",
    value: function renderFiles() {
      var _props4 = this.props,
          schema = _props4.schema,
          uiSchema = _props4.uiSchema,
          idSchema = _props4.idSchema,
          name = _props4.name,
          disabled = _props4.disabled,
          readonly = _props4.readonly,
          autofocus = _props4.autofocus;

      var title = schema.title || name;
      var items = this.state.formData.items;
      var widgets = this.props.registry.widgets;

      var _getUiOptions2 = (0, _utils.getUiOptions)(uiSchema),
          _getUiOptions2$widget = _getUiOptions2.widget,
          widget = _getUiOptions2$widget === undefined ? "files" : _getUiOptions2$widget,
          options = _objectWithoutProperties(_getUiOptions2, ["widget"]);

      var Widget = (0, _utils.getWidget)(schema, widget, widgets);
      return _react2.default.createElement(Widget, {
        options: options,
        id: idSchema && idSchema.$id,
        multiple: true,
        onChange: this.onSelectChange,
        schema: schema,
        title: title,
        value: items,
        disabled: disabled,
        readonly: readonly,
        autofocus: autofocus });
    }
  }, {
    key: "renderFixedArray",
    value: function renderFixedArray() {
      var _this5 = this;

      var _props5 = this.props,
          schema = _props5.schema,
          uiSchema = _props5.uiSchema,
          errorSchema = _props5.errorSchema,
          idSchema = _props5.idSchema,
          name = _props5.name,
          required = _props5.required,
          disabled = _props5.disabled,
          readonly = _props5.readonly,
          autofocus = _props5.autofocus;

      var title = schema.title || name;
      var items = this.state.formData.items;
      var _props$registry3 = this.props.registry,
          definitions = _props$registry3.definitions,
          fields = _props$registry3.fields;
      var TitleField = fields.TitleField;

      var itemSchemas = schema.items.map(function (item) {
        return (0, _utils.retrieveSchema)(item, definitions);
      });
      var additionalSchema = (0, _utils.allowAdditionalItems)(schema) ? (0, _utils.retrieveSchema)(schema.additionalItems, definitions) : null;

      var _getUiOptions3 = (0, _utils.getUiOptions)(uiSchema),
          _getUiOptions3$addabl = _getUiOptions3.addable,
          addable = _getUiOptions3$addabl === undefined ? true : _getUiOptions3$addabl;

      var canAdd = addable && additionalSchema;

      if (!items || items.length < itemSchemas.length) {
        // to make sure at least all fixed items are generated
        items = items || [];
        items = items.concat(new Array(itemSchemas.length - items.length));
      }

      return _react2.default.createElement(
        "fieldset",
        { className: "field field-array field-array-fixed-items" },
        _react2.default.createElement(ArrayFieldTitle, {
          TitleField: TitleField,
          idSchema: idSchema,
          title: title,
          required: required }),
        schema.description ? _react2.default.createElement(
          "div",
          { className: "field-description" },
          schema.description
        ) : null,
        _react2.default.createElement(
          "div",
          { className: "row array-item-list" },
          items.map(function (item, index) {
            var additional = index >= itemSchemas.length;
            var itemSchema = additional ? additionalSchema : itemSchemas[index];
            var itemIdPrefix = idSchema.$id + "_" + index;
            var itemIdSchema = (0, _utils.toIdSchema)(itemSchema, itemIdPrefix, definitions);
            var itemUiSchema = additional ? uiSchema.additionalItems || {} : Array.isArray(uiSchema.items) ? uiSchema.items[index] : uiSchema.items || {};
            var itemErrorSchema = errorSchema ? errorSchema[index] : undefined;

            return _this5.renderArrayFieldItem({
              index: index,
              canRemove: additional,
              canMoveUp: index >= itemSchemas.length + 1,
              canMoveDown: additional && index < items.length - 1,
              itemSchema: itemSchema,
              itemData: item,
              itemUiSchema: itemUiSchema,
              itemIdSchema: itemIdSchema,
              itemErrorSchema: itemErrorSchema,
              autofocus: autofocus && index === 0
            });
          })
        ),
        canAdd ? _react2.default.createElement(AddButton, {
          onClick: this.onAddClick,
          disabled: disabled || readonly }) : null
      );
    }
  }, {
    key: "renderArrayFieldItem",
    value: function renderArrayFieldItem(_ref3) {
      var _this6 = this;

      var index = _ref3.index,
          _ref3$canRemove = _ref3.canRemove,
          canRemove = _ref3$canRemove === undefined ? true : _ref3$canRemove,
          _ref3$canMoveUp = _ref3.canMoveUp,
          canMoveUp = _ref3$canMoveUp === undefined ? true : _ref3$canMoveUp,
          _ref3$canMoveDown = _ref3.canMoveDown,
          canMoveDown = _ref3$canMoveDown === undefined ? true : _ref3$canMoveDown,
          itemSchema = _ref3.itemSchema,
          itemData = _ref3.itemData,
          itemUiSchema = _ref3.itemUiSchema,
          itemIdSchema = _ref3.itemIdSchema,
          itemErrorSchema = _ref3.itemErrorSchema,
          autofocus = _ref3.autofocus,
          anyOfItemsSchema = _ref3.anyOfItemsSchema,
          selectWidgetValue = _ref3.selectWidgetValue;
      var SchemaField = this.props.registry.fields.SchemaField;
      var _props6 = this.props,
          disabled = _props6.disabled,
          readonly = _props6.readonly,
          uiSchema = _props6.uiSchema;

      var _orderable$removable$ = _extends({
        orderable: true,
        removable: true
      }, uiSchema["ui:options"]),
          orderable = _orderable$removable$.orderable,
          removable = _orderable$removable$.removable;

      var has = {
        moveUp: orderable && canMoveUp,
        moveDown: orderable && canMoveDown,
        remove: removable && canRemove
      };
      has.toolbar = Object.keys(has).some(function (key) {
        return has[key];
      });
      var btnStyle = { flex: 1, paddingLeft: 6, paddingRight: 6, fontWeight: "bold" };
      var SelectWidget = this.props.registry.widgets.SelectWidget;


      return _react2.default.createElement(
        "div",
        { key: index, className: "array-item" },
        _react2.default.createElement(
          "div",
          { className: has.toolbar ? "col-xs-9" : "col-xs-12" },
          anyOfItemsSchema ? _react2.default.createElement(
            "div",
            { className: "form-group", style: { width: 120 } },
            _react2.default.createElement(SelectWidget, {
              schema: { type: "integer" },
              id: "test",
              options: { enumOptions: this.anyOfOptions(anyOfItemsSchema) },
              value: selectWidgetValue,
              onChange: function onChange(value) {
                return _this6.setWidgetType(index, value);
              } })
          ) : null,
          _react2.default.createElement(SchemaField, {
            schema: itemSchema,
            uiSchema: itemUiSchema,
            formData: itemData,
            errorSchema: itemErrorSchema,
            idSchema: itemIdSchema,
            required: this.isItemRequired(itemSchema),
            onChange: this.onChangeForIndex(index),
            registry: this.props.registry,
            disabled: this.props.disabled,
            readonly: this.props.readonly,
            autofocus: autofocus })
        ),
        has.toolbar ? _react2.default.createElement(
          "div",
          { className: "col-xs-3 array-item-toolbox" },
          _react2.default.createElement(
            "div",
            { className: "btn-group", style: { display: "flex", justifyContent: "space-around" } },
            has.moveUp || has.moveDown ? _react2.default.createElement(IconBtn, { icon: "arrow-up", className: "array-item-move-up",
              tabIndex: "-1",
              style: btnStyle,
              disabled: disabled || readonly || !has.moveUp,
              onClick: this.onReorderClick(index, index - 1) }) : null,
            has.moveUp || has.moveDown ? _react2.default.createElement(IconBtn, { icon: "arrow-down", className: "array-item-move-down",
              tabIndex: "-1",
              style: btnStyle,
              disabled: disabled || readonly || !has.moveDown,
              onClick: this.onReorderClick(index, index + 1) }) : null,
            has.remove ? _react2.default.createElement(IconBtn, { type: "danger", icon: "remove", className: "array-item-remove",
              tabIndex: "-1",
              style: btnStyle,
              disabled: disabled || readonly,
              onClick: this.onDropIndexClick(index) }) : null
          )
        ) : null
      );
    }
  }, {
    key: "itemTitle",
    get: function get() {
      var schema = this.props.schema;

      return schema.items.title || schema.items.description || "Item";
    }
  }]);

  return ArrayField;
}(_react.Component);

ArrayField.defaultProps = {
  uiSchema: {},
  idSchema: {},
  registry: (0, _utils.getDefaultRegistry)(),
  required: false,
  disabled: false,
  readonly: false,
  autofocus: false
};

var _initialiseProps = function _initialiseProps() {
  var _this7 = this;

  this.onAddClick = function (event) {
    event.preventDefault();
    var items = _this7.state.formData.items;
    var _props7 = _this7.props,
        schema = _props7.schema,
        registry = _props7.registry;
    var definitions = registry.definitions;

    var itemSchema = schema.items;
    var anyOfItems = _this7.getAnyOfItemsSchema();
    if ((0, _utils.isFixedItems)(schema) && (0, _utils.allowAdditionalItems)(schema)) {
      itemSchema = schema.additionalItems;
    }

    var newAnyOfItems = [];
    if (anyOfItems) {
      // We pick the first anyOf item by default
      itemSchema = anyOfItems[0];

      newAnyOfItems = [].concat(_toConsumableArray(_this7.state.anyOfItems), [itemSchema]);
    }

    var newItems = {
      items: items.concat([(0, _utils.getDefaultFormState)(itemSchema, undefined, definitions)])
    };
    var newState = Object.assign({}, _this7.state, { formData: newItems, anyOfItems: newAnyOfItems });
    _this7.asyncSetState(newState);
  };

  this.onDropIndexClick = function (index) {
    return function (event) {
      event.preventDefault();
      var _state2 = _this7.state,
          items = _state2.formData.items,
          anyOfItems = _state2.anyOfItems;

      var newItems = {
        items: items.filter(function (_, i) {
          return i !== index;
        })
      };
      var newAnyOfItems = anyOfItems.filter(function (_, i) {
        return i !== index;
      });
      var newState = Object.assign({}, _this7.state, { formData: newItems, anyOfItems: newAnyOfItems });
      _this7.asyncSetState(newState, { validate: true }); // refs #195
    };
  };

  this.onReorderClick = function (index, newIndex) {
    return function (event) {
      event.preventDefault();
      event.target.blur();
      var _state3 = _this7.state,
          items = _state3.formData.items,
          anyOfItems = _state3.anyOfItems;


      var reorder = function reorder(items, newIndex) {
        return items.map(function (item, i) {
          if (i === newIndex) {
            return items[index];
          } else if (i === index) {
            return items[newIndex];
          } else {
            return item;
          }
        });
      };

      var newItems = {
        items: reorder(items, newIndex)
      };
      var newAnyOfItems = reorder(anyOfItems, newIndex);

      var newState = Object.assign({}, _this7.state, { formData: newItems }, { anyOfItems: newAnyOfItems });
      _this7.asyncSetState(newState, { validate: true });
    };
  };

  this.onChangeForIndex = function (index) {
    return function (value) {
      var items = {
        items: _this7.state.formData.items.map(function (item, i) {
          return index === i ? value : item;
        })
      };
      var newState = Object.assign({}, _this7.state, { formData: items });
      _this7.asyncSetState(newState);
    };
  };

  this.onSelectChange = function (value) {
    var newState = Object.assign({}, _this7.state, { formData: { items: value } });
    _this7.asyncSetState(newState);
  };
};

function AddButton(_ref4) {
  var onClick = _ref4.onClick,
      disabled = _ref4.disabled;

  return _react2.default.createElement(
    "div",
    { className: "row" },
    _react2.default.createElement(
      "p",
      { className: "col-xs-3 col-xs-offset-9 array-item-add text-right" },
      _react2.default.createElement(IconBtn, { type: "info", icon: "plus", className: "btn-add col-xs-12",
        tabIndex: "0", onClick: onClick,
        disabled: disabled })
    )
  );
}

if (process.env.NODE_ENV !== "production") {
  ArrayField.propTypes = {
    schema: _propTypes2.default.object.isRequired,
    uiSchema: _propTypes2.default.shape({
      "ui:options": _propTypes2.default.shape({
        addable: _propTypes2.default.bool,
        orderable: _propTypes2.default.bool,
        removable: _propTypes2.default.bool
      })
    }),
    idSchema: _propTypes2.default.object,
    errorSchema: _propTypes2.default.object,
    onChange: _propTypes2.default.func.isRequired,
    formData: _propTypes2.default.array,
    required: _propTypes2.default.bool,
    disabled: _propTypes2.default.bool,
    readonly: _propTypes2.default.bool,
    autofocus: _propTypes2.default.bool,
    registry: _propTypes2.default.shape({
      widgets: _propTypes2.default.objectOf(_propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.object])).isRequired,
      fields: _propTypes2.default.objectOf(_propTypes2.default.func).isRequired,
      definitions: _propTypes2.default.object.isRequired,
      formContext: _propTypes2.default.object.isRequired
    })
  };
}

exports.default = ArrayField;